#include <cstdio>
#include <cstring>
#include <iostream>
#include <set>
#include <string>
using namespace std;

#define VERBOSE 1

bool check(string in_file, string out_file)
{
	int N,M,K;
	int i,j,r,c;
	string s;
	static char G[2002][2002];
	set<int> row[2002];
	set<int> col[2002];
	set<int>::iterator I;
	freopen(in_file.c_str(),"r",stdin);
	scanf("%d%d",&N,&M);
	K=0;
		for (i=0; i<N; i++)
		{
			scanf("%s",&G[i]);
				for (j=0; j<M; j++)
					if (G[i][j]!='.')
					{
						row[i].insert(j);
						col[j].insert(i);
						K++;
					}
		}
	freopen(out_file.c_str(),"r",stdin);
		while (K--)
		{
				if (!(cin >> s))
				{
						if (VERBOSE)
							printf("not enough strings\n");
					return(0);
				}
				if ((s[0]!='(') || (s[s.size()-1]!=')'))
				{
						if (VERBOSE)
							printf("invalid format\n");
					return(0);
				}
			r=c=0;
				for (i=1; s[i]!=','; i++)
					if ((s[i]>='0') && (s[i]<='9'))
						r=r*10+s[i]-'0';
					else
					{
							if (VERBOSE)
								printf("invalid format\n");
						return(0);
					}
				for (i++; i!=s.size()-1; i++)
					if ((s[i]>='0') && (s[i]<='9'))
						c=c*10+s[i]-'0';
					else
					{
							if (VERBOSE)
								printf("invalid format\n");
						return(0);
					}
				if ((r<0) || (r>=N) || (c<0) || (c>=M))
				{
						if (VERBOSE)
							printf("coords out of bounds\n");
					return(0);
				}
				if (G[r][c]=='.')
				{
						if (VERBOSE)
							printf("no car at coords\n");
					return(0);
				}
				if (G[r][c]=='N')
				{
					I=col[c].find(r);
						if (I!=col[c].begin())
						{
								if (VERBOSE)
									printf("car in the way\n");
							return(0);
						}
				}
				if (G[r][c]=='S')
				{
					I=col[c].find(r),I++;
						if (I!=col[c].end())
						{
								if (VERBOSE)
									printf("car in the way\n");
							return(0);
						}
				}
				if (G[r][c]=='W')
				{
					I=row[r].find(c);
						if (I!=row[r].begin())
						{
								if (VERBOSE)
									printf("car in the way\n");
							return(0);
						}
				}
				if (G[r][c]=='E')
				{
					I=row[r].find(c),I++;
						if (I!=row[r].end())
						{
								if (VERBOSE)
									printf("car in the way\n");
							return(0);
						}
				}
			row[r].erase(c);
			col[c].erase(r);
			G[r][c]='.';
		}
		if (cin >> s)
		{
				if (VERBOSE)
					printf("too many strings\n");
			return(0);
		}
	return(1);
}

int main(int argc, char*argv[])
{
    
	check(std::string(argv[1]),std::string(argv[2]));
	//printf("%d\n",(int)check(std::string(argv[1]),std::string(argv[2])));
	
}
